org.apache.pdfbox.preflight.action

## Class ActionManagerFactory

- java.lang.Object
- - org.apache.pdfbox.preflight.action.ActionManagerFactory

    public class ActionManagerFactory
    extends Object

### Constructor Summary

Constructors
Constructor and Description
`ActionManagerFactory()`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected AbstractActionManager` `createActionManager(PreflightContext ctx, org.apache.pdfbox.cos.COSDictionary action, String aaKey)` Create an instance of ActionManager according to the value of the S entry.
`List<AbstractActionManager>` `getActionManagers(PreflightContext ctx, org.apache.pdfbox.cos.COSDictionary dictionary)` This method extract actions from the given dictionary.
`List<AbstractActionManager>` `getNextActions(PreflightContext ctx, org.apache.pdfbox.cos.COSDictionary actionDictionary)` Returns all actions contained by the Next entry.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ActionManagerFactory

    public ActionManagerFactory()

### Method Detail

#### getActionManagers

    public final List<AbstractActionManager> getActionManagers(PreflightContext ctx,
                                                               org.apache.pdfbox.cos.COSDictionary dictionary)
                                                        throws ValidationException

This method extract actions from the given dictionary. An action is identified by the following entries :

- A (Action) : Available in Annotations, Outline items
- OpenAction (OpenAction) : Available in the Catalog dictionary
- AA (Additional Action) : Available in the Catalog dictionary, Annotations, Pages

If there are no action, an empty list is returned.

Parameters:
  `ctx` - the preflight context.
  `dictionary` - the dictionary to retrieve the actions from.
Returns:
  the list of actions from the given dictionary.
Throws:
  `ValidationException`

#### getNextActions

    public final List<AbstractActionManager> getNextActions(PreflightContext ctx,
                                                            org.apache.pdfbox.cos.COSDictionary actionDictionary)
                                                     throws ValidationException

Returns all actions contained by the Next entry. If the action dictionary doesn't have Next action, the result is an empty list.

Parameters:
  `ctx` - the preflight context.
  `actionDictionary` - the dictionary to retrieve the actions from.
Returns:
  the list of actions from the given dictionary.
Throws:
  `ValidationException`

#### createActionManager

    protected AbstractActionManager createActionManager(PreflightContext ctx,
                                                        org.apache.pdfbox.cos.COSDictionary action,
                                                        String aaKey)
                                                 throws ValidationException

Create an instance of ActionManager according to the value of the S entry. If the type entry isn't Action, a ValidationException will be thrown. If the action type isn't authorized in a PDF/A file, an instance of InvalidAction is returned.

Parameters:
  `ctx` - the preflight context.
  `action` - the action dictionary used to instantiate the ActionManager
  `aaKey` - the Action identifier if it is an additional action
Returns:
  the ActionManager instance.
Throws:
  `ValidationException`